-- ------------------------------------------------
--      DECODIFICADOR PS2 a BCD 
--	Consideracioanes:
--		+ Se toman solo las  5 entradas menos significativas del cdigo PS2
--		+ Las salidas Mum[3..1]

--	Version 30/08/2010
--	Javier Rodrguez

-- ------------------------------------------------

LIBRARY ieee ;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


ENTITY PS2_BCD_321 is		
	
	PORT(
			D		: IN STD_LOGIC_VECTOR (4 downto 0);
			Num		: OUT STD_LOGIC_VECTOR (3 downto 1)
	);
	
END PS2_BCD_321;

ARCHITECTURE funcionamiento of PS2_BCD_321 is

BEGIN
			
	deco: PROCESS (D)
	BEGIN
	
		CASE D IS
	
			WHEN "10000" =>
				Num <= "000"; 
				
			WHEN "01001" =>
				Num <= "000";
				
			WHEN "10010" =>
				Num <= "001";
				
			WHEN "11010" =>
				Num <= "001";
				
			WHEN "01011" =>
				Num <= "010";
				
			WHEN "10011" =>
				Num <= "010";
				
			WHEN "10100" =>
				Num <= "011";
				
			WHEN "01100" =>
				Num <= "011";
				
			WHEN "10101" =>
				Num <= "100";
				
			WHEN "11101" =>
				Num <= "100";
			
			WHEN OTHERS =>
				Num <= "XXX";
				
		END CASE;
		
	END PROCESS;	
	
END;
	
